#ifdef USE_PRAGMA_IDENT_HDR
#pragma ident "@(#)rawMonitor.hpp	1.10 07/03/09 17:16:01 JVM"
#endif
/*
 * Copyright (c) 2007 Sun Microsystems, Inc.  All Rights Reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *   
 * This code is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 only, as
 * published by the Free Software Foundation.
 *   
 * This code is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * version 2 for more details (a copy is included in the LICENSE file that
 * accompanied this code).
 *  
 * You should have received a copy of the GNU General Public License version
 * 2 along with this work; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *   
 * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa Clara,
 * CA 95054 USA or visit www.sun.com if you need additional information or
 * have any questions.
 *  
 */

//
//
// class RawMonitor
// Used by all JVMPI RawMonitor methods: 
//   (CreateRawMonitor, EnterRawMonitor, etc.)
//
// Wrapper for ObjectMonitor class that saves the Monitor's name
// and links thread's owned raw monitors

class RawMonitor: public ObjectMonitor {
private:
  int           _magic;
  char *        _name;
  // maintaining list of locked raw monitors
  RawMonitor* _rmnext;    
  RawMonitor* _rmprev;

public:
  RawMonitor(const char *name, const int magic);
  ~RawMonitor();                             
  int       magic()                         { return _magic;  }
  void      print(outputStream& out)        { out.print(_name); }
  RawMonitor* next_raw() const              { return _rmnext; }
  const char *name() const                  { return _name; }
  void add_to_locked_list();
  void remove_from_locked_list();
  int       raw_destroy();
};

